using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Windows.Controls;

namespace WPFinGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

           
        }

        private System.Windows.Forms.Integration.ElementHost elementHost;
        System.Windows.Forms.Panel panel;

        private void Form1_Load(object sender, EventArgs e)
        {
            this.elementHost = new System.Windows.Forms.Integration.ElementHost();
            this.elementHost.BackColor = System.Drawing.Color.AliceBlue;
            this.elementHost.Dock = System.Windows.Forms.DockStyle.Left;
            this.elementHost.Location = new System.Drawing.Point(0, 0);
            this.elementHost.Name = "elementHost";
            this.elementHost.Size = new System.Drawing.Size(230, 383);
            this.elementHost.TabIndex = 0;
            this.elementHost.TabStop = false;
            this.elementHost.Text = "elementHost1";

            // Create a WPF Expander
            Expander expander = new Expander();
            expander.Header = "WPF Expander";
            expander.Content = "Content";

            // Add it to the ElementHost
            elementHost.Child = expander;
          
            this.panel = new System.Windows.Forms.Panel();
            panel.Controls.Add(elementHost);

            //make big covered cell to hold the WPF control
            this.gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(2, 2, 6, 3));
            this.gridControl1[2, 2].CellType = "Control";
            this.gridControl1[2, 2].Control = panel;

            //used to give a visual queue when cell has input focus
            this.gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
         this.gridControl1.CurrentCellMoved += new GridCurrentCellMovedEventHandler(gridControl1_CurrentCellMoved);

 
        }

        void gridControl1_CurrentCellControlLostFocus(object sender, ControlEventArgs e)
        {
            if (e.Control == this.panel && !this.elementHost.Focused)
            {
                DoDelayedUpdate();
            }
        }

        void gridControl1_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            if (e.RowIndex == 2 && e.ColIndex == 2)
            {
                GridControl grid = sender as GridControl;
                if (grid.CurrentCell.HasCurrentCellAt(e.RowIndex, e.ColIndex))
                {
                    this.elementHost.BackColor = Color.FromArgb(150, System.Drawing.Color.DodgerBlue);
                }
                else
                {
                    this.elementHost.BackColor = System.Drawing.Color.AliceBlue;
                }
            }
        }

        void gridControl1_CurrentCellMoved(object sender, GridCurrentCellMovedEventArgs e)
        {
            GridControl grid = sender as GridControl;
            GridCurrentCell cc = grid.CurrentCell;
            if (cc.MoveFromRowIndex == 2 && cc.MoveFromColIndex == 2)
            {
                DoDelayedUpdate();
            }
        }

        private void DoDelayedUpdate()
        {
            Timer t = new Timer();
            t.Interval = 50;
            t.Tick += new EventHandler(t_Tick);
            t.Start();
        }

        void t_Tick(object sender, EventArgs e)
        {
            Timer t = sender as Timer;
            t.Stop();
            t.Tick -= new EventHandler(t_Tick);
            t.Dispose();
            t = null;
            this.gridControl1.RefreshRange(GridRangeInfo.Cells(2, 2, 6, 3));
        }
       
    }
}